/*
 * HC_SR04.c
 *
 * Created: 24.12.2014 8:39:46
 *  Author:  ..
 */ 
#include <avr/io.h>
#include <avr/interrupt.h>       //  

volatile unsigned char InD_1 = 10,InD_2 = 10,InD_3,SD = 10,Sot_Oprosa;
unsigned char Sifra_ind[11] = {136,235,164,161,195,145,144,171,128,129,247};
	  
#define  Trig 4   //   
#define  Eche 3   //    
#define  PORT PORTD

 ISR (INT1_vect)  //  INT1 
  {		  
	if (SD == 0)
	 {	   
	   TCNT0 = 0;           //  
	   MCUCR &=~(1<<2);     //    INT1	
	   SD = 1;              	      	 
	 }
	else
	 {	
	   register int DFG;  	                  	 
	   SD = TCNT0; 	              //         
	   GICR &=~(1<<7); 	          //    INT1              
	   DFG = SD * 8;     //?
	   DFG = DFG / 58;            //    
	   InD_1 = DFG % 100 / 10;    //  
       InD_2 = DFG % 10;          //  
	   InD_3 = 0;	   	   	
	   SD = 0;	   
	 }    	
  }
 ISR(TIMER0_COMP_vect)	 //1,6ms
  {	  
	volatile static unsigned char Danie;  
	if ( GICR & (1<<7))   
	 {
	   InD_3 = 10, InD_2 = 10, InD_1 = 10;	 // "-"  
	   SD = 0;
	   GICR &=~(1<<7);             //    INT1 
	 }		  	
// **     ** //
	Danie ++;	
	switch (Danie)
	 {
	   case 1:PORTD &=~(1<<2); PORTB = Sifra_ind[InD_3]; PORTD |=(1<<0); break;
	   case 2:PORTD &=~(1<<0); PORTB = Sifra_ind[InD_2]; PORTD |=(1<<1); PORTB &=~(1<<7); break;
	   case 3:PORTD &=~(1<<1); PORTB = Sifra_ind[InD_1]; PORTD |=(1<<2); Danie = 0; break; 
	 }	 		
	Sot_Oprosa ++; 		   	  	 		 
  }	 	
//**************************//
//**************************//
int main(void)
{	
	DDRB = 255;	                  //  
	DDRD |=(1<<0)|(1<<1)|(1<<2);  //  
    OCR0=200;  
	TCCR0=0b0001011;                               
    TIMSK|=(1<<1);	
	DDRD |=(1<<Trig);	          		
	asm("sei");	
  //******************//	
    while(1)
     {
	// **    ** //	 
	   if (Sot_Oprosa == 200)  //   c 
	    {
	      Sot_Oprosa = 0;	 
          Impuls_Trig();        //12us     
	    }	 	  
     }
} 
Impuls_Trig()
 {
   volatile char Temp = 2;	 
   PORT |=(1<<Trig);       
   MCUCR |=(1<<2)|(1<<3);  //     
   GICR |=(1<<7);          //   INT1     
   while (Temp)            // 12us
    {
	  Temp --;	
	}    
   PORT &=~(1<<Trig);  	 
 }

















   